<template>
  <v-row>
    <v-col>
      <v-form>
        <v-card class="mb-5" elevation="0" style="border: thin solid rgba(0, 0, 0, 0.12)">
          <v-card-title class="mb-6 highlight">
            Infos générales
          </v-card-title>
          <v-card-text>
            <v-row>
              <v-col cols="12" sm="4">
                <Field #default="{ errors, field, value }" name="missionName" rules="required|max:255"
                  v-model="flight.missionName">
                  <v-text-field @update:model-value="field.onChange" :model-value="value" label="Nom de mission"
                    data-cy="FlightFormMissionNameInput" density="compact" :error-messages="errors" class="required"
                    :disabled="flight.archived" variant="outlined" color="primary">
                  </v-text-field>
                </Field>
              </v-col>
              <v-col cols="12" sm="4">
                <Field #default="{ errors, field, value }" name="missionNumber" rules="required|max:255"
                  v-model="flight.missionNumber">
                  <v-text-field @update:model-value="field.onChange" :model-value="value" label="Numéro de mission"
                    data-cy="FlightFormMissionNumberInput" density="compact" :error-messages="errors" class="required"
                    :disabled="flight.archived" variant="outlined" color="primary">
                  </v-text-field>
                </Field>
              </v-col>
              <v-col cols="12" sm="4">
                <Field #default="{ errors, field, value }" name="cotamNumber" rules="required|max:255"
                  v-model="flight.cotamNumber">
                  <v-text-field @update:model-value="field.onChange" :model-value="value" label="Numéro COTAM"
                    data-cy="FlightFormCotamNameInput" density="compact" :error-messages="errors" class="required"
                    :disabled="flight.archived" variant="outlined" color="primary">
                  </v-text-field>
                </Field>
              </v-col>
              <v-col cols="12" sm="4">
                <Field #default="{ errors, field, value }" name="aircraft"
                  :rules="`${flight.freeSeating ? '' : 'required'}`" v-model="flight.aircraft">
                  <v-select @update:model-value="field.onChange" :model-value="value" label="Avion"
                    data-cy="FlightFormAircraftInput" density="compact" :error-messages="errors" :items="aircrafts"
                    item-title="name" return-object :class="{ required: !flight.freeSeating }"
                    @change="flight.aircraftName = null; flight.aircraftId = null;" :disabled="flight.archived"
                    variant="outlined" color="primary">
                  </v-select>
                </Field>
              </v-col>
              <v-col cols="12" sm="4" v-if="flight.regulatorUser">
                <Field #default="{ errors }" name="regulatorUser">
                  <v-text-field label="Agent régulateur" data-cy="FlightFormRegulatorUserInput" density="compact" disabled
                    :value="flight.regulatorUser.firstName + ' ' + flight.regulatorUser.lastName" variant="outlined" color="primary">
                  </v-text-field>
                </Field>
              </v-col>
              <v-col cols="12" sm="4">
                <Field #default="{ errors, field, value }" name="legUser" rules="max:255" v-model="flight.legUser">
                  <v-text-field @update:model-value="field.onChange" :model-value="value" label="Agent d'escale"
                    data-cy="FlightFormLegUserInput" density="compact" :error-messages="errors" :disabled="flight.archived"
                    variant="outlined" color="primary">
                  </v-text-field>
                </Field>
              </v-col>
              <v-col cols="12" sm="4" v-if="isFreeSeating(flight)">
                <Field #default="{ errors, field, value }" name="aircraftName"
                  :rules="`${isFreeSeating(flight) ? 'required|max:255' : ''}`" v-model="flight.aircraftName">
                  <v-text-field @update:model-value="field.onChange" :model-value="value" label="Nom de l'avion"
                    data-cy="FlightFormAircraftNameInput" density="compact" :error-messages="errors"
                    :class="{ required: isFreeSeating(flight) }" :disabled="flight.archived" variant="outlined" color="primary">
                  </v-text-field>
                </Field>
              </v-col>
              <v-col cols="12" sm="4" v-if="isFreeSeating(flight)">
                <Field #default="{ errors, field, value }" name="aircraftId"
                  :rules="`${isFreeSeating(flight) ? 'required|max:255' : ''}`" v-model="flight.aircraftId">
                  <v-text-field @update:model-value="field.onChange" :model-value="value"
                    label="Immatriculation de l'avion" data-cy="FlightFormAircraftIdInput" density="compact"
                    :error-messages="errors" :class="{ required: isFreeSeating(flight) }" :disabled="flight.archived"
                    variant="outlined">
                  </v-text-field>
                </Field>
              </v-col>
              <v-col cols="12" sm="4">
                <Field #default="{ field, value }" name="imperialSystem" v-model="flight.imperialSystem">
                  <v-checkbox @update:model-value="field.onChange" :model-value="value" :disabled="flight.archived"
                    density="compact" label="Utiliser le système impérial (livres)" data-cy="FlightFormImperialSystemInput">
                  </v-checkbox>
                </Field>
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>

        <FlightsEditLegForm v-for="(leg, index) in flight.legs" :key="leg.id" :leg="leg" :index="index"
          :archived="flight.archived" @deleteLeg="askDeleteLeg(leg, index)" />

      </v-form>
    </v-col>

    <LazyConfirmDialog v-if="legDialogDelete" v-model="legDialogDelete" :dialogText="legDialogDeleteText"
      :dialogTitle="legDialogDeleteTitle" @confirm="deleteLeg" @close="close" />
  </v-row>
</template>

<script setup lang="ts">
import { Flight } from "~/dto/flight.dto";
import { Aircraft } from "~/dto/aircraft.dto";
import { Leg } from "~/dto/leg.dto";

const props = defineProps<{ flight: Flight }>();

const store = useStore();

const legDialogDelete = ref(false);
const legDialogDeleteText = ref('');
const legIndex: Ref<number | null> = ref(null);
const aircrafts: Ref<Aircraft[]> = computed(() => {
  const aircrafts = [...store.aircrafts];

  // @ts-ignore partial aircraft
  aircrafts.push({ name: 'Free Seating' });

  return aircrafts;
});
const legDialogDeleteTitle = 'Suppression d\'un leg'

const askDeleteLeg = (leg: Leg, index: number) => {
  legDialogDeleteText.value = `Êtes-vous sûr de vouloir supprimer le Leg n°${index + 1} ${leg.departure?.oaci ? leg.departure.oaci + ' > ' : ''} ${leg.arrival?.oaci ?? ''} ?`;
  legIndex.value = index;
  legDialogDelete.value = true;
}

const deleteLeg = () => {
  props.flight.legs.splice(<number>legIndex.value, 1);
  close();
}

const close = () => {
  legDialogDelete.value = false;
  legIndex.value = null;
}

const isFreeSeating = (flight: Flight): boolean => {
  return flight.aircraft?.name === 'Free Seating';
}
</script>
